diff --git a/app/test-pmd/cmdline_flow.c b/app/test-pmd/cmdline_flow.c
index f1fb568211..180fe36e25 100644
--- a/app/test-pmd/cmdline_flow.c
+++ b/app/test-pmd/cmdline_flow.c
@@ -515,8 +515,6 @@ enum index {
 	ACTION_METER_COLOR_MODE,
 	ACTION_METER_INIT_COLOR,
 	ACTION_METER_STATE,
-	ACTION_OF_SET_NW_TTL,
-	ACTION_OF_SET_NW_TTL_NW_TTL,
 	ACTION_OF_DEC_NW_TTL,
 	ACTION_OF_COPY_TTL_OUT,
 	ACTION_OF_COPY_TTL_IN,
@@ -1834,7 +1832,6 @@ static const enum index next_action[] = {
 	ACTION_METER,
 	ACTION_METER_COLOR,
 	ACTION_METER_MARK,
-	ACTION_OF_SET_NW_TTL,
 	ACTION_OF_DEC_NW_TTL,
 	ACTION_OF_COPY_TTL_OUT,
 	ACTION_OF_COPY_TTL_IN,
@@ -1951,12 +1948,6 @@ static const enum index action_meter_mark[] = {
 	ZERO,
 };
 
-static const enum index action_of_set_nw_ttl[] = {
-	ACTION_OF_SET_NW_TTL_NW_TTL,
-	ACTION_NEXT,
-	ZERO,
-};
-
 static const enum index action_of_push_vlan[] = {
 	ACTION_OF_PUSH_VLAN_ETHERTYPE,
 	ACTION_NEXT,
@@ -5458,23 +5449,6 @@ static const struct token token_list[] = {
 		.args = ARGS(ARGS_ENTRY(struct rte_flow_action_meter_mark, state)),
 		.call = parse_vc_conf,
 	},
-	[ACTION_OF_SET_NW_TTL] = {
-		.name = "of_set_nw_ttl",
-		.help = "OpenFlow's OFPAT_SET_NW_TTL",
-		.priv = PRIV_ACTION
-			(OF_SET_NW_TTL,
-			 sizeof(struct rte_flow_action_of_set_nw_ttl)),
-		.next = NEXT(action_of_set_nw_ttl),
-		.call = parse_vc,
-	},
-	[ACTION_OF_SET_NW_TTL_NW_TTL] = {
-		.name = "nw_ttl",
-		.help = "IP TTL",
-		.next = NEXT(action_of_set_nw_ttl, NEXT_ENTRY(COMMON_UNSIGNED)),
-		.args = ARGS(ARGS_ENTRY(struct rte_flow_action_of_set_nw_ttl,
-					nw_ttl)),
-		.call = parse_vc_conf,
-	},
 	[ACTION_OF_DEC_NW_TTL] = {
 		.name = "of_dec_nw_ttl",
 		.help = "OpenFlow's OFPAT_DEC_NW_TTL",
diff --git a/doc/guides/prog_guide/rte_flow.rst b/doc/guides/prog_guide/rte_flow.rst
index a5ff8fd64e..69a0fac619 100644
--- a/doc/guides/prog_guide/rte_flow.rst
+++ b/doc/guides/prog_guide/rte_flow.rst
@@ -2123,23 +2123,6 @@ fields in the pattern items.
    | 1     | END      |
    +-------+----------+
 
-Action: ``OF_SET_NW_TTL``
-^^^^^^^^^^^^^^^^^^^^^^^^^
-This action is deprecated. Consider `Action: MODIFY_FIELD`_.
-
-Implements ``OFPAT_SET_NW_TTL`` ("IP TTL") as defined by the `OpenFlow
-Switch Specification`_.
-
-.. _table_rte_flow_action_of_set_nw_ttl:
-
-.. table:: OF_SET_NW_TTL
-
-   +------------+--------+
-   | Field      | Value  |
-   +============+========+
-   | ``nw_ttl`` | IP TTL |
-   +------------+--------+
-
 Action: ``OF_DEC_NW_TTL``
 ^^^^^^^^^^^^^^^^^^^^^^^^^
 This is a legacy action. Consider `Action: MODIFY_FIELD`_ as alternative.
diff --git a/doc/guides/rel_notes/deprecation.rst b/doc/guides/rel_notes/deprecation.rst
index 40a1f427af..83654b8c1a 100644
--- a/doc/guides/rel_notes/deprecation.rst
+++ b/doc/guides/rel_notes/deprecation.rst
@@ -105,7 +105,7 @@ Deprecation Notices
   is deprecated as ambiguous with respect to the embedded switch. The use of
   these attributes will become invalid starting from DPDK 22.11.
 
-* ethdev: Actions ``OF_SET_NW_TTL``,
+* ethdev: Actions
   ``OF_COPY_TTL_OUT``, ``OF_COPY_TTL_IN`` are deprecated as not supported by
   any PMD, so they will be removed in DPDK 22.11.
 
diff --git a/doc/guides/rel_notes/release_22_11.rst b/doc/guides/rel_notes/release_22_11.rst
index c3ace47ed8..0473fbe9a2 100644
--- a/doc/guides/rel_notes/release_22_11.rst
+++ b/doc/guides/rel_notes/release_22_11.rst
@@ -109,8 +109,8 @@ Removed Items
 * ethdev: removed ``RTE_FLOW_ACTION_TYPE_PHY_PORT``;
   use ``RTE_FLOW_ACTION_TYPE_REPRESENTED_PORT``.
 
-* ethdev: removed ``OF_SET_MPLS_TTL`` and ``OF_DEC_MPLS_TTL`` which are not
-  actually supported by any PMD.
+* ethdev: removed ``OF_SET_MPLS_TTL``, ``OF_DEC_MPLS_TTL`` and
+  ``OF_SET_NW_TTL``  which are not actually supported by any PMD.
   ``MODIFY_FIELD`` action should be used to do packet edits via RTE flow API.
 
 
diff --git a/drivers/net/bnxt/tf_ulp/ulp_rte_handler_tbl.c b/drivers/net/bnxt/tf_ulp/ulp_rte_handler_tbl.c
index 67f20d83c1..3730029f2f 100644
--- a/drivers/net/bnxt/tf_ulp/ulp_rte_handler_tbl.c
+++ b/drivers/net/bnxt/tf_ulp/ulp_rte_handler_tbl.c
@@ -73,10 +73,6 @@ struct bnxt_ulp_rte_act_info ulp_act_info[] = {
 	.act_type                = BNXT_ULP_ACT_TYPE_NOT_SUPPORTED,
 	.proto_act_func          = NULL
 	},
-	[RTE_FLOW_ACTION_TYPE_OF_SET_NW_TTL] = {
-	.act_type                = BNXT_ULP_ACT_TYPE_NOT_SUPPORTED,
-	.proto_act_func          = NULL
-	},
 	[RTE_FLOW_ACTION_TYPE_OF_DEC_NW_TTL] = {
 	.act_type                = BNXT_ULP_ACT_TYPE_NOT_SUPPORTED,
 	.proto_act_func          = NULL
diff --git a/lib/ethdev/rte_flow.c b/lib/ethdev/rte_flow.c
index 25f13e0287..dc54f5197e 100644
--- a/lib/ethdev/rte_flow.c
+++ b/lib/ethdev/rte_flow.c
@@ -192,8 +192,6 @@ static const struct rte_flow_desc_data rte_flow_desc_action[] = {
 	MK_FLOW_ACTION(PORT_ID, sizeof(struct rte_flow_action_port_id)),
 	MK_FLOW_ACTION(METER, sizeof(struct rte_flow_action_meter)),
 	MK_FLOW_ACTION(SECURITY, sizeof(struct rte_flow_action_security)),
-	MK_FLOW_ACTION(OF_SET_NW_TTL,
-		       sizeof(struct rte_flow_action_of_set_nw_ttl)),
 	MK_FLOW_ACTION(OF_DEC_NW_TTL, 0),
 	MK_FLOW_ACTION(OF_COPY_TTL_OUT, 0),
 	MK_FLOW_ACTION(OF_COPY_TTL_IN, 0),
diff --git a/lib/ethdev/rte_flow.h b/lib/ethdev/rte_flow.h
index c60f85690e..f1ed44a01a 100644
--- a/lib/ethdev/rte_flow.h
+++ b/lib/ethdev/rte_flow.h
@@ -2275,17 +2275,6 @@ enum rte_flow_action_type {
 	 */
 	RTE_FLOW_ACTION_TYPE_SECURITY,
 
-	/**
-	 * @deprecated
-	 * @see RTE_FLOW_ACTION_TYPE_MODIFY_FIELD
-	 *
-	 * Implements OFPAT_SET_NW_TTL ("IP TTL") as defined by the OpenFlow
-	 * Switch Specification.
-	 *
-	 * See struct rte_flow_action_of_set_nw_ttl.
-	 */
-	RTE_FLOW_ACTION_TYPE_OF_SET_NW_TTL,
-
 	/**
 	 * @warning This is a legacy action.
 	 * @see RTE_FLOW_ACTION_TYPE_MODIFY_FIELD
@@ -3021,19 +3010,6 @@ struct rte_flow_action_security {
 	void *security_session; /**< Pointer to security session structure. */
 };
 
-/**
- * @deprecated
- * @see RTE_FLOW_ACTION_TYPE_MODIFY_FIELD
- *
- * RTE_FLOW_ACTION_TYPE_OF_SET_NW_TTL
- *
- * Implements OFPAT_SET_NW_TTL ("IP TTL") as defined by the OpenFlow Switch
- * Specification.
- */
-struct rte_flow_action_of_set_nw_ttl {
-	uint8_t nw_ttl; /**< IP TTL. */
-};
-
 /**
  * RTE_FLOW_ACTION_TYPE_OF_PUSH_VLAN
  *